///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBFILESFileOpsResult.h"
#import "DBSerializableProtocol.h"

@class DBFILESDeleteResult;
@class DBFILESMetadata;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `DeleteResult` struct.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBFILESDeleteResult : DBFILESFileOpsResult <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// Metadata of the deleted object.
@property (nonatomic, readonly) DBFILESMetadata *metadata;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param metadata Metadata of the deleted object.
///
/// @return An initialized instance.
///
- (instancetype)initWithMetadata:(DBFILESMetadata *)metadata;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `DeleteResult` struct.
///
@interface DBFILESDeleteResultSerializer : NSObject

///
/// Serializes `DBFILESDeleteResult` instances.
///
/// @param instance An instance of the `DBFILESDeleteResult` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBFILESDeleteResult` API object.
///
+ (nullable NSDictionary *)serialize:(DBFILESDeleteResult *)instance;

///
/// Deserializes `DBFILESDeleteResult` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBFILESDeleteResult` API object.
///
/// @return An instantiation of the `DBFILESDeleteResult` object.
///
+ (DBFILESDeleteResult *)deserialize:(NSDictionary *)dict;

@end

NS_ASSUME_NONNULL_END
