///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGGetTeamEventsResult;
@class DBTEAMLOGTeamEvent;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `GetTeamEventsResult` struct.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGGetTeamEventsResult : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// List of events.
@property (nonatomic, readonly) NSArray<DBTEAMLOGTeamEvent *> *events;

/// Pass the cursor into `getEventsContinue` to obtain additional events.
@property (nonatomic, readonly, copy) NSString *cursor;

/// Is true if there are additional events that have not been returned yet. An
/// additional call to `getEventsContinue` can retrieve them.
@property (nonatomic, readonly) NSNumber *hasMore;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param events List of events.
/// @param cursor Pass the cursor into `getEventsContinue` to obtain additional
/// events.
/// @param hasMore Is true if there are additional events that have not been
/// returned yet. An additional call to `getEventsContinue` can retrieve them.
///
/// @return An initialized instance.
///
- (instancetype)initWithEvents:(NSArray<DBTEAMLOGTeamEvent *> *)events
                        cursor:(NSString *)cursor
                       hasMore:(NSNumber *)hasMore;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `GetTeamEventsResult` struct.
///
@interface DBTEAMLOGGetTeamEventsResultSerializer : NSObject

///
/// Serializes `DBTEAMLOGGetTeamEventsResult` instances.
///
/// @param instance An instance of the `DBTEAMLOGGetTeamEventsResult` API
/// object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGGetTeamEventsResult` API object.
///
+ (nullable NSDictionary *)serialize:(DBTEAMLOGGetTeamEventsResult *)instance;

///
/// Deserializes `DBTEAMLOGGetTeamEventsResult` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGGetTeamEventsResult` API object.
///
/// @return An instantiation of the `DBTEAMLOGGetTeamEventsResult` object.
///
+ (DBTEAMLOGGetTeamEventsResult *)deserialize:(NSDictionary *)dict;

@end

NS_ASSUME_NONNULL_END
