///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGFolderLogInfo;
@class DBTEAMLOGJoinTeamDetails;
@class DBTEAMLOGLinkedDeviceLogInfo;
@class DBTEAMLOGUserLinkedAppLogInfo;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `JoinTeamDetails` struct.
///
/// Additional information relevant when a new member joins the team.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGJoinTeamDetails : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// Linked applications.
@property (nonatomic, readonly) NSArray<DBTEAMLOGUserLinkedAppLogInfo *> *linkedApps;

/// Linked devices.
@property (nonatomic, readonly) NSArray<DBTEAMLOGLinkedDeviceLogInfo *> *linkedDevices;

/// Linked shared folders.
@property (nonatomic, readonly) NSArray<DBTEAMLOGFolderLogInfo *> *linkedSharedFolders;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param linkedApps Linked applications.
/// @param linkedDevices Linked devices.
/// @param linkedSharedFolders Linked shared folders.
///
/// @return An initialized instance.
///
- (instancetype)initWithLinkedApps:(NSArray<DBTEAMLOGUserLinkedAppLogInfo *> *)linkedApps
                     linkedDevices:(NSArray<DBTEAMLOGLinkedDeviceLogInfo *> *)linkedDevices
               linkedSharedFolders:(NSArray<DBTEAMLOGFolderLogInfo *> *)linkedSharedFolders;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `JoinTeamDetails` struct.
///
@interface DBTEAMLOGJoinTeamDetailsSerializer : NSObject

///
/// Serializes `DBTEAMLOGJoinTeamDetails` instances.
///
/// @param instance An instance of the `DBTEAMLOGJoinTeamDetails` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGJoinTeamDetails` API object.
///
+ (nullable NSDictionary *)serialize:(DBTEAMLOGJoinTeamDetails *)instance;

///
/// Deserializes `DBTEAMLOGJoinTeamDetails` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGJoinTeamDetails` API object.
///
/// @return An instantiation of the `DBTEAMLOGJoinTeamDetails` object.
///
+ (DBTEAMLOGJoinTeamDetails *)deserialize:(NSDictionary *)dict;

@end

NS_ASSUME_NONNULL_END
