///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGMemberChangeMembershipTypeDetails;
@class DBTEAMLOGTeamMembershipType;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `MemberChangeMembershipTypeDetails` struct.
///
/// Changed membership type (limited/full) of member.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGMemberChangeMembershipTypeDetails : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// Previous membership type.
@property (nonatomic, readonly) DBTEAMLOGTeamMembershipType *prevValue;

/// New membership type.
@property (nonatomic, readonly) DBTEAMLOGTeamMembershipType *dNewValue;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param prevValue Previous membership type.
/// @param dNewValue New membership type.
///
/// @return An initialized instance.
///
- (instancetype)initWithPrevValue:(DBTEAMLOGTeamMembershipType *)prevValue
                        dNewValue:(DBTEAMLOGTeamMembershipType *)dNewValue;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `MemberChangeMembershipTypeDetails` struct.
///
@interface DBTEAMLOGMemberChangeMembershipTypeDetailsSerializer : NSObject

///
/// Serializes `DBTEAMLOGMemberChangeMembershipTypeDetails` instances.
///
/// @param instance An instance of the
/// `DBTEAMLOGMemberChangeMembershipTypeDetails` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGMemberChangeMembershipTypeDetails` API object.
///
+ (nullable NSDictionary *)serialize:(DBTEAMLOGMemberChangeMembershipTypeDetails *)instance;

///
/// Deserializes `DBTEAMLOGMemberChangeMembershipTypeDetails` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGMemberChangeMembershipTypeDetails` API object.
///
/// @return An instantiation of the `DBTEAMLOGMemberChangeMembershipTypeDetails`
/// object.
///
+ (DBTEAMLOGMemberChangeMembershipTypeDetails *)deserialize:(NSDictionary *)dict;

@end

NS_ASSUME_NONNULL_END
