///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGSecondaryMailsPolicy;
@class DBTEAMLOGSecondaryMailsPolicyChangedDetails;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `SecondaryMailsPolicyChangedDetails` struct.
///
/// Secondary mails policy changed.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGSecondaryMailsPolicyChangedDetails : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// Previous secondary mails policy.
@property (nonatomic, readonly) DBTEAMLOGSecondaryMailsPolicy *previousValue;

/// New secondary mails policy.
@property (nonatomic, readonly) DBTEAMLOGSecondaryMailsPolicy *dNewValue;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param previousValue Previous secondary mails policy.
/// @param dNewValue New secondary mails policy.
///
/// @return An initialized instance.
///
- (instancetype)initWithPreviousValue:(DBTEAMLOGSecondaryMailsPolicy *)previousValue
                            dNewValue:(DBTEAMLOGSecondaryMailsPolicy *)dNewValue;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `SecondaryMailsPolicyChangedDetails` struct.
///
@interface DBTEAMLOGSecondaryMailsPolicyChangedDetailsSerializer : NSObject

///
/// Serializes `DBTEAMLOGSecondaryMailsPolicyChangedDetails` instances.
///
/// @param instance An instance of the
/// `DBTEAMLOGSecondaryMailsPolicyChangedDetails` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGSecondaryMailsPolicyChangedDetails` API object.
///
+ (nullable NSDictionary *)serialize:(DBTEAMLOGSecondaryMailsPolicyChangedDetails *)instance;

///
/// Deserializes `DBTEAMLOGSecondaryMailsPolicyChangedDetails` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGSecondaryMailsPolicyChangedDetails` API object.
///
/// @return An instantiation of the
/// `DBTEAMLOGSecondaryMailsPolicyChangedDetails` object.
///
+ (DBTEAMLOGSecondaryMailsPolicyChangedDetails *)deserialize:(NSDictionary *)dict;

@end

NS_ASSUME_NONNULL_END
