///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"

@class DBTEAMLOGShowcaseChangeDownloadPolicyDetails;
@class DBTEAMLOGShowcaseDownloadPolicy;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `ShowcaseChangeDownloadPolicyDetails` struct.
///
/// Enabled/disabled downloading files from Dropbox Showcase for team.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGShowcaseChangeDownloadPolicyDetails : NSObject <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// New Dropbox Showcase download policy.
@property (nonatomic, readonly) DBTEAMLOGShowcaseDownloadPolicy *dNewValue;

/// Previous Dropbox Showcase download policy.
@property (nonatomic, readonly) DBTEAMLOGShowcaseDownloadPolicy *previousValue;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param dNewValue New Dropbox Showcase download policy.
/// @param previousValue Previous Dropbox Showcase download policy.
///
/// @return An initialized instance.
///
- (instancetype)initWithDNewValue:(DBTEAMLOGShowcaseDownloadPolicy *)dNewValue
                    previousValue:(DBTEAMLOGShowcaseDownloadPolicy *)previousValue;

- (instancetype)init NS_UNAVAILABLE;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `ShowcaseChangeDownloadPolicyDetails`
/// struct.
///
@interface DBTEAMLOGShowcaseChangeDownloadPolicyDetailsSerializer : NSObject

///
/// Serializes `DBTEAMLOGShowcaseChangeDownloadPolicyDetails` instances.
///
/// @param instance An instance of the
/// `DBTEAMLOGShowcaseChangeDownloadPolicyDetails` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGShowcaseChangeDownloadPolicyDetails` API object.
///
+ (nullable NSDictionary *)serialize:(DBTEAMLOGShowcaseChangeDownloadPolicyDetails *)instance;

///
/// Deserializes `DBTEAMLOGShowcaseChangeDownloadPolicyDetails` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGShowcaseChangeDownloadPolicyDetails` API object.
///
/// @return An instantiation of the
/// `DBTEAMLOGShowcaseChangeDownloadPolicyDetails` object.
///
+ (DBTEAMLOGShowcaseChangeDownloadPolicyDetails *)deserialize:(NSDictionary *)dict;

@end

NS_ASSUME_NONNULL_END
