///
/// Copyright (c) 2016 Dropbox, Inc. All rights reserved.
///
/// Auto-generated by Stone, do not modify.
///

#import <Foundation/Foundation.h>

#import "DBSerializableProtocol.h"
#import "DBTEAMLOGUserLogInfo.h"

@class DBTEAMLOGTeamMemberLogInfo;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - API Object

///
/// The `TeamMemberLogInfo` struct.
///
/// Team member's logged information.
///
/// This class implements the `DBSerializable` protocol (serialize and
/// deserialize instance methods), which is required for all Obj-C SDK API route
/// objects.
///
@interface DBTEAMLOGTeamMemberLogInfo : DBTEAMLOGUserLogInfo <DBSerializable, NSCopying>

#pragma mark - Instance fields

/// Team member ID. Might be missing due to historical data gap.
@property (nonatomic, readonly, copy, nullable) NSString *teamMemberId;

/// Team member external ID.
@property (nonatomic, readonly, copy, nullable) NSString *memberExternalId;

#pragma mark - Constructors

///
/// Full constructor for the struct (exposes all instance variables).
///
/// @param accountId User unique ID. Might be missing due to historical data
/// gap.
/// @param displayName User display name. Might be missing due to historical
/// data gap.
/// @param email User email address. Might be missing due to historical data
/// gap.
/// @param teamMemberId Team member ID. Might be missing due to historical data
/// gap.
/// @param memberExternalId Team member external ID.
///
/// @return An initialized instance.
///
- (instancetype)initWithAccountId:(nullable NSString *)accountId
                      displayName:(nullable NSString *)displayName
                            email:(nullable NSString *)email
                     teamMemberId:(nullable NSString *)teamMemberId
                 memberExternalId:(nullable NSString *)memberExternalId;

///
/// Convenience constructor (exposes only non-nullable instance variables with
/// no default value).
///
///
/// @return An initialized instance.
///
- (instancetype)initDefault;

@end

#pragma mark - Serializer Object

///
/// The serialization class for the `TeamMemberLogInfo` struct.
///
@interface DBTEAMLOGTeamMemberLogInfoSerializer : NSObject

///
/// Serializes `DBTEAMLOGTeamMemberLogInfo` instances.
///
/// @param instance An instance of the `DBTEAMLOGTeamMemberLogInfo` API object.
///
/// @return A json-compatible dictionary representation of the
/// `DBTEAMLOGTeamMemberLogInfo` API object.
///
+ (nullable NSDictionary *)serialize:(DBTEAMLOGTeamMemberLogInfo *)instance;

///
/// Deserializes `DBTEAMLOGTeamMemberLogInfo` instances.
///
/// @param dict A json-compatible dictionary representation of the
/// `DBTEAMLOGTeamMemberLogInfo` API object.
///
/// @return An instantiation of the `DBTEAMLOGTeamMemberLogInfo` object.
///
+ (DBTEAMLOGTeamMemberLogInfo *)deserialize:(NSDictionary *)dict;

@end

NS_ASSUME_NONNULL_END
